<?php
// This gets called from a Second Life object when registering and when changing status
// Most of the data will come from the headers (e.g. avatar UUID)
// "action" wil be set to "register" (empty on legacy code) or "status"
// PermURL is the SL-assigned URL during registration to call the object back 
// Our script will also send avatar_name and object_version

if (!$_SERVER['HTTP_X_SECONDLIFE_OWNER_NAME'])
{
	header("HTTP/1.0 405 Method Not Allowed");
	die("Request has to come from Second Life");
}

require_once('../../../wp-blog-header.php');

if ($_REQUEST['action'] == 'status')
{
	$settings = maybe_unserialize(get_option('online_status_insl_settings'));
	
	// change settings just for this avatar
	$avatarLegacyName = $_SERVER['HTTP_X_SECONDLIFE_OWNER_NAME'];

	if ($settings[$avatarLegacyName]) // do we have this avatar on the tracked list?
	{
		$settings[$avatarLegacyName]["Status"] = $_REQUEST['status'];
		$settings[$avatarLegacyName]["avatarDisplayName"] = $_REQUEST['avatar_name'];
		$settings[$avatarLegacyName]["timeStamp"] = time();
		
		update_option('online_status_insl_settings', $settings);

		header("HTTP/1.0 200 OK");
		header("Content-type: text/plain; charset=utf-8");
		echo "Status '" . $_REQUEST['status'] . "' set for '"
			. $avatarLegacyName . "' (" . $_REQUEST['avatar_name'] . ")";
	}
	else
	{
		header("HTTP/1.0 404 Avatar not found");
		echo($_REQUEST['avatar_name'] . " is not yet registered!");
	}
	
}
else if ($permURL = $_REQUEST['PermURL']) // assume it's a registration (legacy support)
{
	$avatarKey = $_SERVER['HTTP_X_SECONDLIFE_OWNER_KEY'];
	$avatarLegacyName = $_SERVER['HTTP_X_SECONDLIFE_OWNER_NAME'];
	$avatarDisplayName = $_REQUEST['avatar_name'];
	$objectVersion = $_REQUEST['object_version']; // we'll ignore versions for now
	$objectKey = $_SERVER['HTTP_X_SECONDLIFE_OBJECT_KEY'];
	$objectName = $_SERVER['HTTP_X_SECONDLIFE_OBJECT_NAME']; // to do some fancy editing
	$objectRegion = $_SERVER['HTTP_X_SECONDLIFE_REGION'];
	$objectLocalPosition = $_SERVER['HTTP_X_SECONDLIFE_LOCAL_POSITION'];
	
	// now get the whole serialised array
		
	$settings = maybe_unserialize(get_option('online_status_insl_settings'));

	$settings[$avatarLegacyName] = array(
		"Status"				=> $_REQUEST['status'] ? $_REQUEST['status'] : 'state unknown', 
		"PermURL"				=> $_REQUEST['PermURL'], 
		"avatarKey"				=> $avatarKey, 
		"avatarDisplayName" 	=> $avatarDisplayName, 
		"objectVersion" 		=> $objectVersion, 
		"objectKey"				=> $objectKey, 
		"objectName"			=> $objectName, 
		"objectRegion"			=> $objectRegion, 
		"objectLocalPosition"	=> $objectLocalPosition,
		"timeStamp"				=> time()
	);
	
	update_option('online_status_insl_settings', $settings);
	
	header("HTTP/1.0 200 OK");
	header("Content-type: text/plain; charset=utf-8");
	echo "PermURL <" . $settings[$avatarLegacyName]["PermURL"] . "> saved for user $avatarLegacyName.";
}
else
{
	header("HTTP/1.0 405 Method Not Allowed");
	echo "No PermURL specified on registration";
}
?>